/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		Bck Database
Company		Engineering
Author		Spagic Team
Version		2.0.0
Database    mySQL 5 
*/

Create table process_instance (
	id_process_instance Bigint(20) NOT NULL AUTO_INCREMENT,
	id_process Bigint NOT NULL,
	startdate Datetime NOT NULL,
	enddate Datetime NOT NULL,
	state Int(11) NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_pool Bigint,
 Primary Key (id_process_instance)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table transition_instance (
	id_journal Bigint(20) NOT NULL AUTO_INCREMENT,
	id_step_source Bigint,
	id_step_target Bigint NOT NULL,
	id_process_instance Bigint(20) NOT NULL,
	id_message Varchar(100) NOT NULL,
	transition_start Timestamp NOT NULL,
	transition_end Timestamp,
	id_ext_process_instance Varchar(45),
	id_state Int NOT NULL,
	transition_data Blob,
 Primary Key (id_journal)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table log_journal (
	id_log Bigint(20) NOT NULL AUTO_INCREMENT,
	id_state Int NOT NULL,
	id_journal Bigint NOT NULL,
	name Varchar(200),
	log Text NOT NULL,
	datelog Datetime NOT NULL,
 Primary Key (id_log)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table relevant_data (
	id_relevant_data Bigint NOT NULL AUTO_INCREMENT,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 Primary Key (id_relevant_data)) ENGINE = InnoDB;

Create table pool_instance (
	id_pool Bigint NOT NULL AUTO_INCREMENT,
	id_pool_type Bigint NOT NULL,
	unique_pool_instance_key Varchar(1000) NOT NULL,
 Primary Key (id_pool)) ENGINE = InnoDB;

Create table relevant_data_process_instance (
	id_process_instance Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 Primary Key (id_process_instance,id_relevant_data)) ENGINE = InnoDB;
