/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		Bck Database
Company		Engineering
Author		Spagic Team
Version		2.0.0
Database    Oracle 9i
*/

Create table process_instance (
	id_process_instance Integer NOT NULL ,
	id_process Integer NOT NULL ,
	startdate Timestamp(9) NOT NULL ,
	enddate Timestamp(9) NOT NULL ,
	state Integer NOT NULL ,
	id_correlation Varchar2 (100) NOT NULL ,
	id_pool Integer,
primary key (id_process_instance) 
) 
;

Create table transition_instance (
	id_journal Integer NOT NULL ,
	id_step_source Integer,
	id_step_target Integer NOT NULL ,
	id_process_instance Integer NOT NULL ,
	id_message Varchar2 (100) NOT NULL ,
	transition_start Timestamp(0) NOT NULL ,
	transition_end Timestamp(0),
	id_ext_process_instance Varchar2 (45),
	id_state Integer NOT NULL ,
	transition_data Blob,
primary key (id_journal) 
) 
;

Create table log_journal (
	id_log Integer NOT NULL ,
	id_state Integer NOT NULL ,
	id_journal Integer NOT NULL ,
	name Varchar2 (200),
	log Clob NOT NULL ,
	datelog Timestamp(9) NOT NULL ,
primary key (id_log) 
) 
;

Create table relevant_data (
	id_relevant_data Integer NOT NULL ,
	id_attribute Integer NOT NULL ,
	id_log Integer NOT NULL ,
	value Varchar2 (500) NOT NULL ,
primary key (id_relevant_data) 
) 
;

Create table pool_instance (
	id_pool Integer NOT NULL ,
	id_pool_type Integer NOT NULL ,
	unique_pool_instance_key Varchar2 (1000) NOT NULL ,
primary key (id_pool) 
) 
;

Create table relevant_data_process_instance (
	id_process_instance Integer NOT NULL ,
	id_relevant_data Integer NOT NULL ,
primary key (id_process_instance,id_relevant_data) 
) 
;
